<template>
  <div class="main">
    <div v-if="!isId">
      <h1>You must first choose a Cocktail !</h1>
      <router-link class="btn-router" to="/"> Back</router-link>
    </div>
    <div v-else>
      <DetailedCocktail :cocktail="myCocktail">
        <h3>You chose the best cocktail !</h3>
      </DetailedCocktail>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import DetailedCocktail from "../components/DetailedCocktail/DetailedCocktail.vue";
import { DCocktail } from "@/assets/js/Cocktails.js";

export default {
  name: "Cocktail",
  components: {
    DetailedCocktail,
  },
  data() {
    return {
      myCocktail: Object,
      id: null,
      isId: false,
    };
  },
  mounted() {
    this.id = this.$route.params.id ;
    if (this.id != 0) {
      this.isId = true;
      this.getById();
    }
  },
  methods: {
    getById() {
      axios
        .get(
          `https://www.thecocktaildb.com/api/json/v1/1/lookup.php?i=${this.id}`
        )
        .then((res) => {
          let data = [];
          data.push(res.data.drinks);
          this.convertDataToDCocktail(data[0]);
        })
        .catch((err) => {
          console.err(err);
        });
    },
    convertDataToDCocktail(data) {
      let d = data[0];
      let id = d.idDrink;
      let name = d.strDrink;
      let glassName = d.strGlass;
      let instruction = d.strInstructions;
      let category = d.strCategory;
      let alcoholic = d.strAlcoholic;
      let image = d.strDrinkThumb;
      let ingredients = [];
      ingredients.push(
        this.pushItems(
          d.strIngredient1, d.strIngredient2, d.strIngredient3,
          d.strIngredient4, d.strIngredient5, d.strIngredient6, d.strIngredient7,
          d.strIngredient8, d.strIngredient9, d.strIngredient10, d.strIngredient11,
          d.strIngredient12, d.strIngredient13, d.strIngredient14, d.strIngredient15
        )
      );
      let measures = [];
      measures.push(
        this.pushItems(
          d.strMeasure1, d.strMeasure2,d.strMeasure3,
          d.strMeasure4, d.strMeasures5, d.strMeasure6, d.strMeasure7,
          d.strMeasure8, d.strMeasure9, d.strMeasure10,d.strMeasure11,
          d.strMeasure12, d.strMeasure13,d.strMeasure14, d.strMeasure15
        )
      );
      let ing = this.convertIntoObject(ingredients[0], measures[0]);
      this.myCocktail = new DCocktail(
        id,
        name,
        glassName,
        instruction,
        category,
        alcoholic,
        image,
        ing
      );
    },
    convertIntoObject(ing, mes) {
      let tab = new Array();
      for (let i = 0; i < ing.length; i++) {
        let toAdd = {
          ingredient: ing[i],
          measure: mes[i],
        };
        tab.push(toAdd);
      }
      return tab;
    },
    pushItems(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i13, i14, i15) {
      let tab = new Array();
      if (i1 != null & i1 != "") tab.push(i1);
      if (i2 != null & i2 != "") tab.push(i2);
      if (i3 != null & i3 != "") tab.push(i3);
      if (i4 != null & i4 != "") tab.push(i4);
      if (i5 != null & i5 != "") tab.push(i5);
      if (i6 != null & i6 != "") tab.push(i6);
      if (i7 != null & i7 != "") tab.push(i7);
      if (i8 != null & i8 != "") tab.push(i8);
      if (i9 != null & i9 != "") tab.push(i9);
      if (i10 != null & i10 != "") tab.push(i10);
      if (i11 != null & i11 != "") tab.push(i11);
      if (i12 != null & i12 != "") tab.push(i12);
      if (i13 != null & i13 != "") tab.push(i13);
      if (i14 != null & i14 != "") tab.push(i14);
      if (i15 != null & i15 != "") tab.push(i15);
      return tab;
    },
  },
};
</script>

<style lang="scss">
.main {
  padding: 6rem;
}

.btn-router {
  padding: 2rem;
  color: black;
  font-size: 3rem;
  display: inline-block;
}

.btn-router:hover {
  color: white;
}
</style>